<template>
  <el-form ref="form" :model="form" :rules="rules">
    <ele-pro-table
      ref="table"
      :needPage="false"
      :columns="columns"
      @columns-change="handleColumnChange"
      :cache-key="cacheKeyUrl"
      max-height="500px"
      :datasource="form.datasource"
      class="time-form"
    >
      <!-- 表头工具栏 -->
      <template v-slot:toolbar>
        <div class="headbox">
          <div>
            <el-button
              size="small"
              type="primary"
              icon="el-icon-plus"
              class="ele-btn-icon"
              @click="handParent('', -1)"
              v-if="!isContractId"
            >
              新增
            </el-button>
          </div>
        </div>
      </template>

      <template v-slot:requirementTotalCount="{ row, $index }">
        <el-button type="text" @click="handleGetBillDetail(row, 1)">{{
          row.requirementTotalCount
        }}</el-button>
      </template>
      <template v-slot:planTotalCount="{ row, $index }">
        <el-button type="text" @click="handleGetBillDetail(row, 2)">{{
          row.planTotalCount
        }}</el-button>
      </template>
      <template v-slot:inquiryTotalCount="{ row, $index }">
        <el-button type="text" @click="handleGetBillDetail(row, 3)">{{
          row.inquiryTotalCount
        }}</el-button>
      </template>
      <template v-slot:contractTotalCount="{ row, $index }">
        <el-button type="text" @click="handleGetBillDetail(row, 4)">{{
          row.contractTotalCount
        }}</el-button>
      </template>
      <template v-slot:doneTotalCount="{ row, $index }">
        <el-button type="text" @click="handleGetBillDetail(row, 5)">{{
          row.doneTotalCount
        }}</el-button>
      </template>
      <template v-slot:waitTotalCount="{ row, $index }">
        <el-button type="text" @click="handleGetBillDetail(row, 6)">{{
          row.waitTotalCount
        }}</el-button>
      </template>
      <template v-slot:taskName="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.taskName'"
        >
          <el-input
            v-model="scope.row.taskName"
            placeholder="请选择"
            style="width: 60%; margin-right: 10px"
            disabled
          ></el-input>
          <el-button
            v-if="scope.row.productCode"
            size="small"
            type="primary"
            @click.native="handleTaskinstance(scope.row, scope.$index)"
            >选择
          </el-button>
        </el-form-item>
      </template>
      <template v-slot:productName="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.productName'"
          :rules="{
            required: true,
            message: '请输入',
            trigger: 'change'
          }"
        >
          <el-input
            v-model="row.productName"
            :disabled="isContractId"
            placeholder="请输入"
            @click.native="handParent(row, $index)"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:productCode="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.productCode'"
        >
          <el-input v-model="scope.row.productCode" disabled></el-input>
        </el-form-item>
      </template>
      <template v-slot:productCategoryName="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.productCategoryName'"
        >
          <el-input v-model="scope.row.productCategoryName" disabled></el-input>
        </el-form-item>
      </template>
      <template v-slot:taxRate="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.taxRate'"
        >
          <el-input v-model="scope.row.taxRate" @input="getNotaxSinglePrice">
            <template slot="append">%</template>
          </el-input>
        </el-form-item>
      </template>
      <template v-slot:totalCount="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.totalCount'"
          :rules="{
            required: true,
            message: '请输入',
            trigger: 'blur'
          }"
        >
          <el-input
            :disabled="isContractId"
            v-model="scope.row.totalCount"
            placeholder="请输入"
            @input="changeCount(scope.row, scope.$index)"
            type="number"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:totalPrice="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.totalPrice'"
        >
          {{ (Number(scope.row.totalPrice) || 0).toFixed(2) }}元
        </el-form-item>
      </template>

      <template v-slot:productBrand="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.productBrand'"
        >
          <el-input v-model="scope.row.productBrand" disabled></el-input>
        </el-form-item>
      </template>

      <template v-slot:modelType="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.modelType'"
        >
          <el-input v-model="scope.row.modelType" disabled></el-input>
        </el-form-item>
      </template>
      <template v-slot:specification="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.specification'"
        >
          <el-input v-model="scope.row.specification" disabled></el-input>
        </el-form-item>
      </template>
      <template v-slot:deliveryDays="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.deliveryDays'"
          :rules="{
            pattern: numberReg,
            message: '请输入数字',
            trigger: 'blur'
          }"
        >
          <el-input
            v-model="scope.row.deliveryDays"
            @change="setDeliveryDays(scope.row, scope.$index, 'deliveryDays')"
            :disabled="isContractId"
            placeholder="请输入"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:guaranteePeriod="scope">
        <div class="period">
          <div class="borderleftnone">
            <el-form-item
              style="margin-bottom: 20px"
              :prop="'datasource.' + scope.$index + '.guaranteePeriod'"
              :rules="{
                pattern: numberReg,
                message: '请输入数字',
                trigger: 'blur'
              }"
            >
              <el-input
                v-model="scope.row.guaranteePeriod"
                :disabled="isContractId"
                @change="
                  setDeliveryDays(scope.row, scope.$index, 'guaranteePeriod')
                "
                placeholder="请输入"
              ></el-input>
            </el-form-item>
          </div>
          <div class="borderrightnone">
            <DictSelection
              dictName="质保期单位"
              clearable
              v-model="scope.row.guaranteePeriodUnitCode"
              :disabled="isContractId"
              @change="
                setDeliveryDays(scope.row, scope.$index, 'guaranteePeriod')
              "
            >
            </DictSelection>
          </div>
        </div>
      </template>
      <!-- <template v-slot:guaranteePeriodUnitCode="scope"> </template> -->
      <template v-slot:measuringUnit="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.measuringUnit'"
        >
          <el-input
            v-model="scope.row.measuringUnit"
            :disabled="isContractId && !!scope.row.productCode"
            placeholder="请输入"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:remark="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.remark'"
        >
          <el-input
            :disabled="isContractId"
            v-model="scope.row.remark"
            type="textarea"
            placeholder="请输入"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:singlePrice="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.singlePrice'"
          :rules="{
            required: true,
            pattern: numberReg,
            message: '请输入正确的单价',
            trigger: 'change'
          }"
        >
          <el-input
            :disabled="isContractId"
            v-model="scope.row.singlePrice"
            placeholder="请输入"
            @input="getTotalPrice"
          >
            <template slot="append">元</template>
          </el-input>
        </el-form-item>
      </template>
      <!-- <template v-slot:notaxSinglePrice="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.notaxSinglePrice'"
        >
          <el-input
            v-model="scope.row.notaxSinglePrice"
            placeholder="请输入"
            type="number"
          >
            <template slot="append">元</template>
          </el-input>
        </el-form-item>
      </template> -->

      <template v-slot:singleWeight="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :rules="{
            required: false,
            pattern: numberReg,
            trigger: 'change'
          }"
          :prop="'datasource.' + scope.$index + '.singleWeight'"
        >
          <el-input
            :disabled="isContractId"
            v-model="scope.row.singleWeight"
            @input="singleWeightChange(scope.row, scope.$index)"
            placeholder="请输入"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:technicalAnswerName="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.technicalAnswerName'"
        >
          <el-input
            :disabled="isContractId"
            v-model="row.technicalAnswerName"
            placeholder="请输入"
            @click.native="handHead(row, $index)"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:technicalParams="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.technicalParams'"
        >
          <el-input
            :disabled="isContractId"
            type="textarea"
            v-model="scope.row.technicalParams"
            placeholder="请输入"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:supplierMark="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.supplierMark'"
        >
          <el-input
            v-model="scope.row.supplierMark"
            placeholder="请输入"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:technicalDrawings="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.technicalDrawings'"
        >
          <fileMain
            v-model="scope.row.technicalDrawings"
            :type="isContractId ? 'view' : ''"
          ></fileMain>
        </el-form-item>
      </template>
      <template v-slot:guaranteePeriodDeadline="scope">
        <el-form-item
          :prop="'datasource.' + scope.$index + '.guaranteePeriodDeadline'"
        >
          <el-date-picker
            style="width: 140px"
            v-model="scope.row.guaranteePeriodDeadline"
            :disabled="isContractId"
            type="date"
            placeholder="选择日期"
          >
          </el-date-picker>
        </el-form-item>
      </template>
      <template v-slot:deliveryDeadline="scope">
        <el-form-item
          :prop="'datasource.' + scope.$index + '.deliveryDeadline'"
        >
          <el-date-picker
            :disabled="isContractId"
            style="width: 140px"
            v-model="scope.row.deliveryDeadline"
            type="date"
            placeholder="选择日期"
          >
          </el-date-picker>
        </el-form-item>
      </template>
      <template v-slot:provenance="scope">
        <el-form-item :prop="'datasource.' + scope.$index + '.provenance'">
          <DictSelection
            dictName="产地"
            clearable
            v-model="scope.row.provenance"
            multiple
          >
          </DictSelection>
        </el-form-item>
      </template>
      <template v-slot:headerDeadline="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:headerSupplierMark="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:headerProductName="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:headerTotalCount="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:headerSinglePrice="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:batchNo="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.batchNo'"
        >
          <el-input v-model="scope.row.batchNo" placeholder="请输入" v-no-chinese>
          </el-input>
        </el-form-item>
      </template>
      <!-- 操作列 -->
      <template v-slot:action="{ row, $index }">
        <el-popconfirm
          class="ele-action"
          title="确定要删除吗？"
          @confirm="remove(row, $index)"
        >
          <template v-slot:reference>
            <el-link type="danger" :underline="false" icon="el-icon-delete">
              删除
            </el-link>
          </template>
        </el-popconfirm>
      </template>
      <template v-slot:pricingWay="scope">
        <el-form-item
          :prop="'datasource.' + scope.$index + '.pricingWay'"
          :rules="{
            required: true,
            message: '请选择计价方式',
            trigger: 'change'
          }"
        >
          <el-select v-model="scope.row.pricingWay" placeholder="请选择">
            <el-option
              v-for="item in pricingWayList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
              @click.native="changeCount(scope.row, scope.$index)"
            >
            </el-option>
          </el-select>
        </el-form-item>
      </template>
      <template v-slot:headerPricingWay="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
    </ele-pro-table>

    <product-list
      ref="productListRef"
      classType="1"
      :isGetInventoryTotal="true"
      @changeParent="changeParent"
    ></product-list>
    <head-list ref="headRef" @changeParent="changeAnswer"></head-list>
    <bill-detail-dialog
      :bill-detail-dialog-flag.sync="billDetailDialogFlag"
      v-if="billDetailDialogFlag"
      ref="billDetailDialogRef"
    ></bill-detail-dialog>
    <taskinstance-dialog
      ref="taskinstanceDialogRef"
      v-if="taskinstanceDialogFlag"
      @saveTaskInstance="saveTaskInstance"
      :visible.sync="taskinstanceDialogFlag"
    ></taskinstance-dialog>
  </el-form>
</template>
<script>
  import { emailReg, phoneReg, numberReg, positiveIntegerReg } from 'ele-admin';
  import productList from '@/BIZComponents/product-list.vue';
  import dictMixins from '@/mixins/dictMixins';
  import store from '@/store';
  import fileUpload from '@/components/upload/fileUpload';
  import headList from '@/BIZComponents/user-select/user-select.vue';
  import { getFile } from '@/api/system/file';
  import { getByCode } from '@/api/system/dictionary-data';
  import fileMain from '@/components/addDoc/index.vue';
  import billDetailDialog from './billDetailDialog.vue';
  import taskinstanceDialog from '@/BIZComponents/procedure/taskinstanceDialog.vue';
  import { getCode } from '@/components/addDoc/api/index.js';
  import { pricingWayList, lbjtList } from '@/enum/dict.js';
  import { getInventoryTotalAPI } from '@/api/wms';
  import tabMixins from '@/mixins/tableColumnsMixin';

  const dayjs = require('dayjs');

  export default {
    mixins: [dictMixins,tabMixins],
    props: {
      isContractId: {
        type: Boolean,
        default: false
      },
      pricingWay: {
        type: [Number, String],
        default: 1
      },
      supplierMark: {
        type: [Number, String],
        default: ''
      },
      detailType: {
        default: 0
      }
    },
    components: {
      taskinstanceDialog,
      fileMain,
      productList,
      fileUpload,
      billDetailDialog,
      headList
    },
    computed: {
      canHandl() {
        return this.form.datasource.length;
      },
      contractId() {
        return this.$store.state.order.contractId;
      }
    },

    data() {
      const defaultForm = {
        key: null,
        endTime: '',
        isFirst: 0,
        name: '',
        startTime: '',
        workHour: '',
        technicalDrawings: []
      };
      return {
        cacheKeyUrl: 'eos-purchasingManage-purchaseOrder-inventoryTable',
        pricingWayList,
        discountTotalPrice: 0.0,
        allPrice: 0.0,
        numberReg,
        positiveIntegerReg,
        defaultForm,
        contractStartDate: new Date(),
        form: {
          datasource: []
        },
        rules: {},
        dictList: {},
        billDetailDialogFlag: false,
        taskinstanceDialogFlag: false,
        columns: [
          {
            width: 45,
            type: 'index',
            columnKey: 'index',
            align: 'center',
            fixed: 'left'
          },
          {
            width: 200,
            prop: 'productName',
            label: '名称',
            slot: 'productName',
            headerSlot: 'headerProductName',
            align: 'center',
            fixed: 'left'
          },
          {
            width: 120,
            prop: 'productCode',
            label: '编码',
            slot: 'productCode',
            align: 'center'
          },
          {
            width: 120,
            prop: 'requirementTotalCount',
            label: '采购需求数量',
            slot: 'requirementTotalCount',
            align: 'center'
          },
          {
            width: 120,
            prop: 'planTotalCount',
            label: '采购计划数量',
            slot: 'planTotalCount',
            align: 'center'
          },
          {
            width: 120,
            prop: 'inquiryTotalCount',
            label: '采购核价数量',
            slot: 'inquiryTotalCount',
            align: 'center'
          },
          {
            width: 120,
            prop: 'contractTotalCount',
            label: '采购合同数量',
            slot: 'contractTotalCount',
            align: 'center'
          },
          {
            width: 80,
            prop: 'doneTotalCount',
            label: '已采数量',
            slot: 'doneTotalCount',
            align: 'center'
          },
          {
            width: 80,
            prop: 'waitTotalCount',
            label: '待采数量',
            // slot: 'waitTotalCount',
            align: 'center'
          },
          {
            width: 150,
            prop: 'totalCount',
            label: '数量',
            slot: 'totalCount',
            headerSlot: 'headerTotalCount',
            align: 'center'
          },
          {
            width: 120,
            prop: 'availableCountBase',
            label: '库存数量',
            slot: 'availableCountBase',
            align: 'center'
          },
          {
            width: 160,
            prop: 'pricingWay',
            label: '计价方式',
            headerSlot: 'headerPricingWay',
            slot: 'pricingWay',
            align: 'center'
          },
          {
            width: 160,
            prop: 'singlePrice',
            label: '单价(含税)',
            slot: 'singlePrice',
            headerSlot: 'headerSinglePrice',
            align: 'center',
            show: !this.detailType
          },
          {
            width: 180,
            prop: 'notaxSinglePrice',
            label: '不含税单价',
            slot: 'notaxSinglePrice',
            align: 'center',
            show: !this.detailType
          },
          {
            width: 150,
            prop: 'taxRate',
            label: '税率',
            slot: 'taxRate',
            align: 'center',
            show: !this.detailType
          },
          {
            width: 120,
            prop: 'supplierMark',
            label: '供应商代号',
            // headerSlot: 'headerSupplierMark',
            slot: 'supplierMark',
            align: 'center'
          },
          {
            width: 200,
            prop: 'productCategoryName',
            label: '类型',
            slot: 'productCategoryName',
            showOverflowTooltip: true,
            align: 'center'
          },
          {
            minWidth: 240,
            prop: 'taskName',
            label: '工序',
            slot: 'taskName',
            align: 'center'
          },
          {
            width: 160,
            prop: 'productBrand',
            label: '牌号',
            slot: 'productBrand',
            showOverflowTooltip: true,
            align: 'center'
          },
          {
            width: 120,
            prop: 'modelType',
            label: '型号',
            slot: 'modelType',
            align: 'center'
          },
          {
            width: 120,
            prop: 'specification',
            label: '规格',
            slot: 'specification',
            align: 'center'
          },
          {
            width: 120,
            prop: 'imgCode',
            align: 'center',
            label: '图号/件号',
            showOverflowTooltip: true
          },
          {
            width: 120,
            prop: 'produceType',
            align: 'center',
            label: '属性类型',
            showOverflowTooltip: true,
            formatter: (row, column) => {
              if (row.produceType) {
                return row.produceType
                  .map((item) => {
                    return lbjtList[item];
                  })
                  .toString();
              }
            }
          },

          {
            width: 120,
            prop: 'packingSpecification',
            align: 'center',
            label: '包装规格',
            showOverflowTooltip: true
          },

          {
            width: 80,
            prop: 'measuringUnit',
            label: '计量单位',
            slot: 'measuringUnit',
            align: 'center'
          },
          {
            width: 120,
            prop: 'singleWeight',
            label: '单重',
            slot: 'singleWeight',
            align: 'center'
          },
          {
            width: 120,
            prop: 'totalWeight',
            label: '总重',
            slot: 'totalWeight',
            align: 'center'
          },
          {
            width: 120,
            prop: 'weightUnit',
            label: '重量单位',
            slot: 'weightUnit',
            align: 'center'
          },

          {
            width: 160,
            prop: 'discountSinglePrice',
            label: '折后单价(含税)',
            slot: 'discountSinglePrice',
            align: 'center',
            show: !this.detailType
          },

          {
            width: 120,
            prop: 'totalPrice',
            label: '合计(含税)',
            slot: 'totalPrice',
            align: 'center',
            show: !this.detailType
          },
          {
            width: 120,
            prop: 'discountTotalPrice',
            label: '折后合计(含税)',
            slot: 'discountTotalPrice',
            align: 'center',
            show: !this.detailType
          },
          {
            width: 110,
            prop: 'batchNo',
            label: '批次号',
            slot: 'batchNo',
            align: 'center'
          },
          {
            prop: 'provenance',
            label: '产地',
            slot: 'provenance',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 200
          },

          {
            width: 160,
            prop: 'deliveryDeadline',
            label: '交期截止日期',
            slot: 'deliveryDeadline',
            align: 'center'
            // headerSlot: 'headerDeadline'
          },
          {
            width: 200,
            prop: 'guaranteePeriod',
            label: '质保期',
            slot: 'guaranteePeriod',
            align: 'center'
          },
          {
            width: 160,
            prop: 'guaranteePeriodDeadline',
            label: '	质保截止日期',
            slot: 'guaranteePeriodDeadline',
            align: 'center'
          },
          // {
          //   width: 120,
          //   prop: 'guaranteePeriodUnitCode',
          //   label: '',
          //   slot: 'guaranteePeriodUnitCode'
          // },
          {
            width: 130,
            prop: 'technicalAnswerName',
            label: '技术答疑人',
            slot: 'technicalAnswerName',
            align: 'center'
          },
          {
            width: 220,
            prop: 'technicalParams',
            label: '技术参数',
            slot: 'technicalParams',
            align: 'center'
          },
          {
            width: 240,
            prop: 'technicalDrawings',
            label: '技术图纸',
            slot: 'technicalDrawings',
            align: 'center'
          },
          {
            width: 220,
            prop: 'remark',
            label: '备注',
            slot: 'remark',
            align: 'center'
          },
          {
            columnKey: 'action',
            label: '操作',
            width: 120,
            align: 'center',
            resizable: false,
            slot: 'action',
            fixed: 'right',
            showOverflowTooltip: true
          }
        ]
      };
    },
    created() {
      this.requestDict('生产类型');
    },
    methods: {
      handleGetBillDetail(row, type) {
        this.billDetailDialogFlag = true;
        this.$nextTick(() => {
          this.$refs.billDetailDialogRef.open(row, type);
        });
      },

      downloadFile(file) {
        getFile({ objectName: file.storePath }, file.name);
      },
      // 返回列表数据
      getTableValue() {
        let comitDatasource = this.form.datasource;

        if (comitDatasource.length === 0) return [];
        comitDatasource.forEach((v, i) => {
          v.detailType = this.detailType;

          v.guaranteePeriodUnitName = this.getDictValue(
            '质保期单位',
            v.guaranteePeriodUnitCode
          );
          v.technicalDrawings = Array.isArray(v.technicalDrawings)
            ? v.technicalDrawings
            : [];
        });

        return comitDatasource;
      },
      getPrice() {
        return [this.allPrice];
      },
      //改变数量
      changeCount(row, index) {
        if (this.detailType) {
          return;
        }

        this.singleWeightChange(row, index);
        this.getTotalPrice();
      },
      //计算总金额
      getTotalPrice(row, index) {
        this.getNotaxSinglePrice();

        if (this.form.datasource.length) {
          let sum = 0;
          sum = this.getNumTotalPrice();
          let allsum = sum.toFixed(2);
          this.allPrice = allsum;
          this.form.discountTotalPrice = allsum;
          this.$store.commit('concact/setDiscountAmount', allsum);
          this.$store.commit('order/setAllcountAmount', allsum);
          this.$emit('orderDiscountAmount', this.allPrice);
          this.$refs.table.reload();
          return allsum;
        } else {
          this.allPrice = 0.0;
          this.form.discountTotalPrice = 0.0;
          this.$emit('orderDiscountAmount', 0);
          return 0.0;
        }
      },
      //计算不含税单价
      getNotaxSinglePrice() {
        this.form.datasource.forEach((item, index) => {
          if (item.singlePrice && item.taxRate) {
            this.$set(
              this.form.datasource[index],
              'notaxSinglePrice',
              parseFloat(
                (item.singlePrice / (1 + item.taxRate / 100)).toFixed(2)
              )
            );
          } else {
            this.$set(this.form.datasource[index], 'notaxSinglePrice', '');
          }
        });
      },
      //计算总金额
      getNumTotalPrice() {
        console.log(111);
        let sum = 0;
        this.form.datasource.forEach((r) => {
          this.$set(
            r,
            'discountSinglePrice',
            r.singlePrice ? Number(r.singlePrice) : ''
          );
          if (r.singlePrice && r.totalCount) {
            r.totalPrice = this.getAllPrice(r);
            r.discountTotalPrice = this.getDiscountTotalPrice(r);
            this.$set(r, 'totalPrice', Number(r.totalPrice));
            this.$set(r, 'discountTotalPrice', Number(r.discountTotalPrice));
            sum += Number(r.totalPrice);
          } else {
            this.$set(r, 'totalPrice', '');
            this.$set(r, 'discountTotalPrice', '');
          }
        });
        return sum;
      },

      //计算单重
      singleWeightChange(row, index) {
        if (row && row.singleWeight && row.totalCount) {
          row.totalWeight = (row.singleWeight * row.totalCount).toFixed(2) || 0;
          this.$set(
            this.form.datasource[index],
            'totalWeight',
            row.totalWeight
          );
        }
        if (row.pricingWay == 2) {
          this.getTotalPrice(row);
        }
      },
      //设置优惠后总金额修改产品单价
      discountInputByOrder(val) {
        this.form.discountTotalPrice = val;
        //获取优惠金额和总计的差价
        this.form.datasource.forEach((item) => {
          if (val === 0) {
            item.discountTotalPrice = 0;
            item.discountSinglePrice = 0;
            return;
          }
          if (!val) {
            item.discountTotalPrice = item.totalPrice;
            item.discountSinglePrice = item.singlePrice;
            return;
          }
          //获取折让单价
          item.discountSinglePrice = this.getDiscountSinglePrice(item);
          item.discountTotalPrice = this.getDiscountTotalPrice(item);
        });
        this.$refs.table.reload();
        this.$store.commit('concact/setDiscountAmount', val);
      },
      //获取折让单价
      getDiscountSinglePrice(row) {
        let num =
          (Number(this.form.discountTotalPrice) / Number(this.allPrice)) *
          Number(row.singlePrice);
        return isNaN(num) ? '' : num.toFixed(2);
      },
      handleTaskinstance(row, index) {
        this.taskinstanceDialogFlag = true;
        this.$nextTick(() => {
          this.$refs.taskinstanceDialogRef.open(row, index);
        });
      },
      saveTaskInstance(row = {}) {
        this.$set(this.form.datasource[row.index], 'taskId', row.id);
        this.$set(this.form.datasource[row.index], 'taskName', row.name);
        this.$set(
          this.form.datasource[row.index],
          'routingId',
          row.produceRoutingId
        );
      },
      //获取合计
      getAllPrice(row) {
        let num = 0;
        if (row.pricingWay == 1) {
          num = Number(row.singlePrice) * Number(row.totalCount);
        }
        if (row.pricingWay == 2) {
          num =
            Number(row.singlePrice) *
            Number(row.totalCount) *
            Number(row.singleWeight);
        }
        console.log(row, 'row');

        return isNaN(num) ? '' : num.toFixed(2);
      },
      //获取折让合计
      getDiscountTotalPrice(row) {
        let num = 0;
        if (row.pricingWay == 1) {
          num = Number(row.discountSinglePrice) * Number(row.totalCount);
        }
        if (row.pricingWay == 2) {
          num =
            Number(row.discountSinglePrice) *
            Number(row.totalCount) *
            Number(row.singleWeight);
        }

        return isNaN(num) ? '' : num.toFixed(2);
      },
      //修改回显
      async putTableValue(data, contractStartDate) {
        if (contractStartDate) {
          this.contractStartDate = contractStartDate;
        }
        if (data) {
          data.forEach((item) => {
            item.guaranteePeriodUnitCode = item.guaranteePeriodUnitCode
              ? item.guaranteePeriodUnitCode + ''
              : '';
          });
          console.log(data, 'data');
          this.form.datasource = data;
          this.allPrice = this.$store.state.order.allcountAmount;
          let codeList = this.form.datasource
            .filter((item) => item.productCode)
            .map((item) => item.productCode);
          //获取仓库库存
          let inventoryTotalList = await getInventoryTotalAPI(codeList);
          this.form.datasource
            .filter((item) => item.productCode)
            .forEach((item, index) => {
              let find =
                inventoryTotalList.find(
                  (key) => key.code == item.productCode
                ) || {};
              this.form.datasource;
              this.$set(
                this.form.datasource[index],
                'availableCountBase',
                find.availableCountBase
              );
            });
        }
      },
      //选择产品
      handParent(row, index) {
        let item = {
          id: row.productCode
        };
        this.$refs.productListRef.open(item, index);
      },
      //选择技术人回调
      changeAnswer(obj, idx) {
        this.$set(this.form.datasource[idx], 'technicalAnswerId', obj.id);
        this.$set(this.form.datasource[idx], 'technicalAnswerName', obj.name);
      },
      handHead(row, index) {
        let item = {
          id: row.technicalAnswerId
        };
        this.$refs.headRef.open(item, index);
      },
      getGoodsListData(obj = []) {
        obj.forEach((item) => {
          this.$set(item, 'supplierMark', this.supplierMark);
          this.form.datasource.push(item);
        });
      },
      setCustomerMark(supplierMark) {
        console.log(supplierMark);
        this.form.datasource.forEach((item, index) => {
          this.$set(this.form.datasource[index], 'supplierMark', supplierMark);
          console.log(
            this.form.datasource[index],
            'this.form.datasource[index]'
          );
        });
      },
      //选择产品回调
      changeParent(obj = [], idx) {
        obj.forEach(async (item, index) => {
          let i = idx == -1 ? index : idx;
          let row = JSON.parse(JSON.stringify(this.defaultForm));
          row.key = this.form.datasource.length + 1;
          let parasm = idx == -1 ? row : this.form.datasource[i];
          this.$set(parasm, 'productId', item.id);
          this.$set(parasm, 'categoryName', item.name);
          this.$set(parasm, 'productCategoryId', item.categoryLevelId);
          this.$set(parasm, 'productBrand', item.brandNum);
          this.$set(parasm, 'productCategoryName', item.categoryLevelPath);
          this.$set(parasm, 'productCode', item.code);
          this.$set(parasm, 'productName', item.name);
          this.$set(parasm, 'modelType', item.modelType);
          this.$set(parasm, 'availableCountBase', item.availableCountBase);
          this.$set(parasm, 'measuringUnit', item.measuringUnit);
          this.$set(parasm, 'specification', item.specification);
          this.$set(parasm, 'weightUnit', item.weightUnit);
          this.$set(parasm, 'imgCode', item.imgCode);
          this.$set(parasm, 'produceType', item.componentAttribute);
          this.$set(parasm, 'approvalNumber', item.extField?.approvalNumber);
          this.$set(parasm, 'singleWeight', item.roughWeight);
          this.$set(parasm, 'pricingWay', item.pricingWay || 1);

          this.$set(
            parasm,
            'packingSpecification',
            item.extField?.packingSpecification
          );
          this.$set(parasm, 'supplierMark', this.supplierMark);
          this.$set(parasm, 'batchNo', await getCode('1900101420390125570'));
          if (item.purchaseOrigins?.length > 0) {
            item.purchaseOrigins = item.purchaseOrigins.map((val) => val + '');
          }
          this.$set(parasm, 'provenance', item.purchaseOrigins || []);
          if (idx == -1) {
            this.form.datasource.push(row);
          }
        });
      },
      remove(row, index) {
        this.form.datasource.splice(index, 1);
        // let index = this.form.datasource.findIndex((n) => n.key == row.key);
        // if (index !== -1) {
        //   this.form.datasource.splice(index, 1);
        //   this.setSort();
        // }
      },
      // 清空表格
      restTable() {
        this.form.datasource = [];
      },
      // 重新排序
      setSort() {
        this.form.datasource.forEach((n, index) => {
          n.key = index + 1;
        });
      },
      // 添加
      handlAdd() {
        let item = JSON.parse(JSON.stringify(this.defaultForm));
        item.key = this.form.datasource.length + 1;
        this.form.datasource.push(item);
      },
      setDeliveryDays(row, index, type) {
        if (type == 'deliveryDays') {
          this.$set(
            this.form.datasource[index],
            'deliveryDeadline',
            this.setDay(row.deliveryDays)
          );
        }
        if (type == 'guaranteePeriod') {
          let guaranteePeriodUnitName = this.guaranteePeriodUnit(
            row.guaranteePeriodUnitCode
          );
          this.$set(
            this.form.datasource[index],
            'guaranteePeriodDeadline',
            guaranteePeriodUnitName != 'second'
              ? this.setDay(row.guaranteePeriod, guaranteePeriodUnitName)
              : ''
          );
        }
      },
      guaranteePeriodUnit(code) {
        return code == 3
          ? 'day'
          : code == 4
          ? 'month'
          : code == 5
          ? 'year'
          : 'second';
      },
      setDay(addDay, dateType = 'day') {
        return dayjs(this.contractStartDate || new Date())
          .add(addDay, dateType)
          .format('YYYY-MM-DD');
      },

      validateForm(callback) {
        let singleWeightData = {};
        this.form.datasource.forEach((item) => {
          if (item.pricingWay == 2 && !item.singleWeight) {
            singleWeightData['name'] = item.productName;
          }
        });
        if (singleWeightData.name) {
          this.$message.warning(
            singleWeightData.name + '计价方式为重量，单重不能为空'
          );
          callback(false);
        }
        //开始表单校验
        this.$refs.form.validate((valid) => {
          callback(valid);
        });
      }
    }
  };
</script>
<style lang="scss" scoped>
  .headbox {
    display: flex;
    justify-content: space-between;
    align-items: center;

    .amount {
      font-size: 14px;
      font-weight: bold;
      padding-right: 30px;
    }
  }

  .time-form .el-form-item {
    margin-bottom: 0 !important;
  }

  ::v-deep .period {
    display: flex;

    .borderleftnone {
      .el-input--medium .el-input__inner {
        border-top-right-radius: 0;
        border-bottom-right-radius: 0;
      }
    }

    .borderrightnone {
      .el-input--medium .el-input__inner {
        border-top-left-radius: 0;
        border-bottom-left-radius: 0;
      }
    }
  }

  ::v-deep .time-form tbody > tr:hover > td {
    background-color: transparent !important;
  }

  ::v-deep .time-form .el-table tr {
    background-color: #ffffff;
  }

  .pricebox {
    display: flex;
    justify-content: flex-start;
    align-items: center;
    font-weight: bold;
  }
</style>
